/*
	Conversion et test sur caractres spciaux
*/
#include <stdio.h>
#include <string.h>
#include "key.h"
#include "etc.h"

/*
	Convertit un caractre franais en son quivalent anglais
	Fait rien si ce n'est pas un caractre franais
*/

export char char_fr2ang (char carac)
{
	if (carac > 127){
		switch (carac){
		case KEYIBM_ACONFLEX:
		case KEYISO_ACONFLEX:
		case KEYIBM_AGRAVE:
		case KEYISO_AGRAVE:
			carac = 'a';
			break;
		case KEYIBM_EGRAVE:
		case KEYISO_EGRAVE:
		case KEYIBM_ECONFLEX:
		case KEYISO_ECONFLEX:
		case KEYIBM_EAIGU:
		case KEYISO_EAIGU:
			carac = 'e';
			break;
		case KEYIBM_ICONFLEX:
		case KEYISO_ICONFLEX:
			carac = 'i';
			break;
		case KEYIBM_OCONFLEX:
		case KEYISO_OCONFLEX:
			carac = 'o';
			break;
		case KEYIBM_UGRAVE:
		case KEYISO_UGRAVE:
		case KEYIBM_UCONFLEX:
		case KEYISO_UCONFLEX:
			carac = 'u';
			break;
		case KEYIBM_CCDILLE:
		case KEYISO_CCDILLE:
			carac = 'c';
			break;
		}
	}
	return carac;
}

/*
	Convertit un caractre s'il fait partie d'un ensemble selon un deuxime
	Retourne le caractre convertit ou le caractre original si aucune
	conversion ne s'appliquait
*/

export char char_lookup (
	char carac,		/* caractre  convertir */
	const char *lookup,	/* table  lire */
	const char *tbcnv)	/* Table  utiliser pour convertir carac */
{
	const char *pt = (const char *) strchr (lookup,carac);
	if (pt != NULL) carac = tbcnv[(int)(pt-lookup)];
	return (carac);
}


#ifdef TEST

void main (void)
{
	char *pt = "";
	while (*pt != '\0'){
		printf ("%c -> %c\n",*pt,char_fr2ang(*pt));
		pt++;
	}
}
#endif


