#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "etc.h"

/*
	Ouvre un fichier en mode binaire
	retourne NULL si peut ouvrir
*/
export FILE *fopen_bin(
	const char *fname,
	const char *mode)
{
#if	defined(MSDOS) || defined(OS2) || defined(NT)
	char newmod[10];
	if (strchr(mode,'b') == NULL){
		newmod[0] = *mode++;
		newmod[1] = 'b';
		strcpy (newmod+2,mode);
		return fopen_share(fname,newmod);
	}
#endif
	return fopen_share(fname,mode);
}

/*
	Ouvre un fichier avec fopen_bin en signalant erreur
	avec error_printf()
*/
export FILE *fopen_binerr (
	const char *fname,
	const char *mode,
	int quit)		/* Termine execution si erreur */
{
	FILE *f = fopen_bin (fname,mode);
	if (f == NULL){
		fopen_prterr (fname,strchr(mode,'r')!=NULL,quit);
	}
	return (f);
}

