#include <stdio.h>
#include <string.h>
#include <assert.h>
#include "etc.h"

/*
	Ecrit dans un fichier avec ajout optionnel d'un retour '\r' pour
	simuler les fichiers DOS.

	ATTENTION: limite dimension crite a 32000

	Retourne le nombre d'lment crit. Si une conversion est demande,
	retourne le nombre de bytes.
*/
export int fwrite_dos (
	const void *data,
	int sizelm,
	int nbelm,
	FILE *fout,
	bool addcr)		/* Ajoute cr devant lf ? */
{
	int ret;
#ifdef UNIX
	if (addcr){
		/* Convertit en format DOS */
		char bufcnv[50000];
		char *ptcnv = bufcnv;
		char *ptdata = (char*)data;
		int i;
		int size = sizelm * nbelm;
		assert(size < 32000);
		for (i=0; i<size; i++){
			if (ptdata[0] == '\n') *ptcnv++ = '\r';
			*ptcnv++ = *ptdata++;
		}
		ret = fwrite (bufcnv,1,(ptcnv-bufcnv),fout);
	}else{
		ret = fwrite (data,sizelm,nbelm,fout);
	}
#else
	ret = fwrite (data,sizelm,nbelm,fout);
#endif
	return ret;
}


/*
	Ecrit dans un fichier avec ajout optionnel d'un retour '\r' pour
	simuler les fichiers DOS.


	Retourne le dernier byte ecrit ou EOF si erreur.
*/
export int fputs_dos(
	const char *str,
	FILE *fout,
	int addcr)
{
	int len   = strlen(str);
	int nbecr = fwrite_dos (str,1,len,fout,addcr);
	return nbecr > 0 ? str[len-1] : EOF;
}

