#include <stdarg.h>
#include <fcntl.h>
#include "etc.h"
#include "etc.m"

/*
	Ouvre un fichier en mode binaire
	retourne -1 si peut ouvrir
*/
export int open_bin(
	const char *fname,
	int mode,
	int acces)		/* Sert seulement avec O_CREAT */
{
#if	defined(MSDOS) || defined (OS2) || defined(NT)
	mode |= O_BINARY;
#endif
	return open(fname,mode,acces);
}

/*
	Ouvre un fichier avec open_bin en signalant erreur
	avec error_printf()
*/
export int open_binerr (
	const char *fname,
	int mode,
	int acces,		/* Sert seulement avec O_CREAT */
	int quit)		/* Termine execution si erreur */
{
	int f = open_bin (fname,mode,acces);
	if (f == -1){
		fprintf (stderr,MSG_U(E_CANTOPEN
			,"Ne peut ouvrir %s\n"),fname);
		if (quit) exit(-1);
	}
	return f;
}

