/*
	conversion et expansion de chaine
*/

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include "etc.h"


/*
	traduit, convertit une chaine dans un autre en remplacant symboles
	Les symboles sont des sous-chaines.
	tb[][0] contient des sous-chaine  remplacer.
	tb[][1] contient la chaine de remplacement.
	Aucune chaine tb[i][0] ne doit etre une sous-chaine de tb[j][0] o
	j > i
*/

export void str_expand (
	const char *str,		/* chaine a expandre */
	char *dest,				/* resultat */
	char *tb[][2],	/* const C++ ??? macro,texte correspondant */
	int   nbtb)				/* nombre d'item dans tb */
{
	int tblen[50];
	assert (nbtb<50);
	{
		int i;
		for (i=0; i<nbtb; i++){
			tblen[i] = strlen(tb[i][0]);
		}
	}
	while (*str != '\0'){
		int i;
		for (i=0; i<nbtb; i++){
			if (strncmp(str,tb[i][0],tblen[i])==0){
				dest = stpcpy (dest,tb[i][1]);
				str += tblen[i];
				break;
			}
		}
		if (i == nbtb) *dest++ = *str++;
	}
	*dest = '\0';
}
#if 0

/*
	traduit, convertit une chaine dans un autre en remplacant symboles
	Les symboles sont des sous-chaines.
	tb[][0] contient des sous-chaine  remplacer.
	tb[][1] contient la chaine de remplacement.
	Aucune chaine tb[i][0] ne doit etre une sous-chaine de tb[j][0] o
	j > i
*/

export void str_expand (
	const char *str,		/* chaine a expandre */
	char *dest,				/* resultat */
	const char *tb[][2],	/* const C++ ??? macro,texte correspondant */
	int   nbtb)				/* nombre d'item dans tb */
{
	int tblen[50];
	assert (nbtb<50);
	{
		int i;
		for (i=0; i<nbtb; i++){
			tblen[i] = strlen(tb[i][0]);
		}
	}
	while (*str != '\0'){
		int i;
		for (i=0; i<nbtb; i++){
			if (strncmp(str,tb[i][0],tblen[i])==0){
				dest = stpcpy (dest,tb[i][1]);
				str += tblen[i];
				break;
			}
		}
		if (i == nbtb) *dest++ = *str++;
	}
	*dest = '\0';
}
#endif
