/*
	opration diverse sur les tables de chaine allou dynamiquement
*/
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <misc.h>
#include "etc.h"

#if 0
/*
	libre les lments d'une table de chaine
	Gnralement, chaque lment a t allou par strdup()
*/
export void tbstr_free (char *tb[], int nbelm)
{
	int i;
	for (i=0; i<nbelm; i++) free (tb[i]);
}
#endif

/*
	calcul la longueur total des chaines d'une table
*/
export int tbstr_len (
	const char *tbstr[],
	int nbstr)
{
	int len = 0;
	int i;
	for (i=0; i<nbstr; i++){
		len += strlen(tbstr[i]);
	}
	return (len);
}
/*
	Dtermine la longueur de la plus longue chaine d'une table
*/
export int tbstr_maxlen (
	const char *tbstr[],
	int nbstr)
{
	int maxlen = 0;
	int i;
	for (i=0; i<nbstr; i++){
		int len = strlen(tbstr[i]);
		if (len > maxlen) maxlen = len;
	}
	return (maxlen);
}
/*
	Spare une chaine en une table de chaine
	Utilis tbstr_free pour librer tb[]
*/	
export int tbstr_str2tb(
	const char *str,	/* Chaine  sparer */
	char mark,			/* Sparateur des sous-chaines */
						/* Remplac par '\0' */
	char *tb[])			/* recrevra les sous-chaines avec strdup() */
{
	int nb = 0;
	char *buf = strdup (str);
	char *pt  = buf;
	assert (buf!=NULL);
	while (*pt != '\0'){
		char *pt2 = strchr(pt,mark);
		if (pt2 != NULL){
			*pt2++ = '\0';
		}else{
			pt2 = "";		/* force terminaison la prochaine fois */
		}
		tb[nb++] = strdup(pt);
		pt = pt2;
	}
	free (buf);
	return (nb);
}
/*
	Copie les chaines d'une table dans une chaine en concantnant
	Utilis tbstr_free pour librer tb[]
	Retourne la longueur de la chaine
*/	
export int tbstr_2str(
	const char *tbstr[],/* recrevra les sous-chaines avec strdup() */
	int   nbstr,		/* nombre de chaine */
	char mark,			/* Sparateur qui sera plac entre les chaines */
						/* Si '\0', les chaines seront colls */
	char *str)			/* Destination (doit tre de longueur suffisante) */
{
	char *debstr = str;
	int i;
	for (i=0; i<nbstr; i++){
		str = stpcpy (str,tbstr[i]);
		if (mark != '\0') *str++ = mark;
	}
	*str = '\0';
	return ((int)(str-debstr));
}
/*
	Copie les chaines d'une table dans une chaine alloue en concantnant
	Utilis free() pour librer le rsultat
	Retourne un pointeur vers la chaine allou dinamyquement
*/	
export char *tbstr_2strdup(
	const char *tbstr[],/* recrevra les sous-chaines avec strdup() */
	int   nbstr,		/* nombre de chaine */
	char mark)			/* Sparateur qui sera plac entre les chaines */
						/* Si '\0', les chaines seront colls */
{
	int len = tbstr_len (tbstr,nbstr) + 1 + ((mark != '\0') ? nbstr : 0);
	char *ret = (char*) malloc (len);
	if (ret != NULL){
		tbstr_2str (tbstr,nbstr,mark,ret);
	}
	return (ret);
}

/*
	Elimine les blancs devant et aprs chaque chaine d'une table
*/

export void tbstr_skipstrip (char *tb[], int nb)
{
	int i;
	for (i=0; i<nb; i++){
		char *pt = str_skip (tb[i]);
		str_strip (pt,tb[i]);
	}
}

