#include <string.h>
#include <fcntl.h>
#include <tool.h>
#include "etc.h"


/*
	Ouverture d'un fichier dans un rpertoire virtuel.
	(voir les fonction vdir_xxxx)

	Vrifie si le path fname correspond existe localement ou dans
	l'archive.

	Si le fichier est ouvert en criture et que le fichier est prsent
	dans l'archive et pas localement, le fichier sera copier localement
	avant l'ouverture.

	Retourne NULL si erreur ou ne peut ouvrir ou fichier existe pas.

	Attention: L'ouverture en criture seulement est identique 
		fopen (un peu plus lent peut-tre).
*/
export FILE *vfopen (
	const char *fname,
	const char *mode)
{
	char reel[MAXSIZ_PATH];
	int exist = vdir_exist (fname,reel);
	if (exist == 2){
		/*
			Le fichier est prsent dans l'archive.
			Si ouverture pour modification (pas seulement criture),
			on doit copier le fichier
		*/
		if (strchr(mode,'a') != NULL
			|| strchr(mode,'+') != NULL){
			if (file_copyp(reel,fname)==-1) return NULL;
		}else if (strchr(mode,'w')==NULL){
			fname = reel;
		}
	}
	return fopen_share (fname,mode);
}

