#include <stdio.h>
#include <stdarg.h>
#include "lexc.h"

static char bufinfo[100];
static int  is_lock;
static int  nberr=0;
/*
	Oublie information sur prochaine erreur
*/
void lexcerr_unlock (void)
{
	is_lock = 0;
}

/*
	Enregistre la ligne et fichier courant pour prochaine erreur
*/
void lexcerr_lockinfo (void)
{
	sprintf (bufinfo,"[%s:%d] ",filesrc_curfile(),filesrc_curline());
	is_lock = 1;
}
	

/*
	Impression de message d'erreur lexicale
*/
void lexcerr_bprintf (const char *ctl, ...)
{
	if (!is_lock) lexcerr_lockinfo();
	fprintf (stderr,"%s",bufinfo);
	is_lock = 0;
	{
		va_list list;
		va_start (list,ctl);
		vfprintf (stderr,ctl,list);
		va_end   (list);
	}
	nberr++;
}

/*
	Remet le compteur d'erreur  0.
*/
export void lexcerr_reset (void)
{
	nberr = 0;
}

/*
	Retourne le nombre d'erreur dtectes par le prprocesseur.
*/
export int lexcerr_getnb(void)
{
	return nberr;
}

