/*
    Output du nouveau source
*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <assert.h>
#include <etc.h>
#include "lexc.h"
#include "lexc.m"

static FILE *fout=NULL;
static int   lastline;
static int   lastcol;       /* position de la derniere ecriture */
/*
	Ouvre un fichier pour la rcriture des tokens
*/
export void outsrc_open (char *nomout)
{
    if (nomout == NULL){
        fout = NULL;
    }else{
        fout = fopen (nomout,"w");
        if (fout==NULL){
            fprintf (stderr,MSG_B(E_OPENOUT
				,"Ne peut ouvrir fichier de sortie %s\n"
				,"Can't open output file %s\n"),nomout);
            fout = stdout;
        }
	}
    lastline = 0;
    lastcol  = 0;
}
/*
	Ferme le fichier de rcriture de source C
*/
export void outsrc_close (void)
{
    if (fout != NULL && fout != stdout){
        fclose (fout);
        fout = NULL;
    }
}

static int tab_val=8;
/*
	Enregistre la dimension d'un tab pour regnration d'un source
	Par dfaut, utilise 8.
*/
export void outsrc_settab (int tab)
{
	tab_val = tab;
}
static void	prtout (int	noline,	int	nocar, char	*texte)
{
    int i;
    if (fout == NULL) return;
    if (lastline < noline){
		fprintf	(fout,"\n");
        lastcol = 0;
    }
    if (nocar < lastcol){
        fprintf (fout,"\n");
        lastcol = 0;
    }
	if (lastcol<nocar-1){
		int	tab	= lastcol - (lastcol % tab_val);
		int nxttab = tab+tab_val;
		while (nxttab <=	nocar){
			tab = nxttab;
			nxttab += tab_val;
			fprintf	(fout,"\t");
		}
		lastcol	= tab;
	}
	for	(i=lastcol;	i<nocar; i++) fprintf (fout," ");
    lastline = noline;
    lastcol  = nocar;
    {
        char *pt = texte;
		while (*pt != '\0'){
            if (*pt == '\n'){
                lastcol = 0;
                lastline++;
			}else{
                lastcol++;
            }
            pt++;
		}
    }
    fprintf (fout,"%s",texte);
}
/*
    Retourne la position courante d'criture dans la ligne
*/
export int outsrc_curcol(void)
{
    return (lastcol);
}
/*
    Output d'un chaine arbitraire dans le fichier d'criture de source
	Sans effet si outsrc_open n'a pas t fait
	Retourne le nombre de caractre gnr
*/
export int outsrc_print (char *ctl,...)
{
	int	nbcar=0;
	if (fout != NULL){
		va_list	list;
		static char	*buffer=NULL;
		if (buffer == NULL){
			buffer = (char *)malloc_err(20000,1);
		}
		va_start (list,ctl);
		nbcar =	vsprintf (buffer,ctl,list);
		va_end   (list);
		prtout   (lastline,lastcol,buffer);
	}
	return (nbcar);
}
/*
    Output d'un token dans le fichier d'criture de source
*/
export void outsrc_prttoken (TOKEN *tok)
{
	if (fout != NULL){
		TOKCOM *comment = tok->comment;
		if (comment != NULL){
			prtout (comment->noline, comment->nocar, comment->texte);
		}
		prtout (tok->noline,tok->nocar,token_txt(tok));
	}
}
