#include <assert.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <etc.h>
#include "lexc.h"
#include "lexc.m"

static void skipif(char *line)
{
	while (filesrc_fill(line)!=-1 && strncmp(line,"#endif",6)!=0){
        outsrc_print ("%s\n",line);
        if(strncmp(line,"#if",3)==0) skipif(line);
	}
    outsrc_print ("%s\n",line);
}
/*
	Enregistre une dfinition pour le remplacement prprocesseur
	La chaine de dfinition est du type XXX=YYY ou XXX
*/
export void token_setdef (const char *def)
{
	char buffer[200];
	char *ptbuf = buffer;	/* Pointe sur buffer ou apres ) */
	char *tbprm[30];
	int   nbprm = -1;
	strcpy (buffer,def);
	char *repl = strchr(ptbuf,'=');
	{
		/* #Spcification: preprocesseur/macros

			On peut dfinir une macro avec argument sur la ligne
			de commande. Ceci n'est pas standard.

			ex: -Df(x)=x-2
		*/
		char *paren = strchr(buffer,'(');
		if (paren != NULL && (repl == NULL || repl > paren)){
			char *endpar = strchr(paren,')');
			if (endpar != NULL){
				*paren  = '\0';
				*endpar = '\0';
				nbprm = tbstr_str2tb(paren+1,',',tbprm);
				ptbuf = endpar+1;
			}else{
				fprintf (stderr,MSG_B(E_IVLDMACDEF
					,"Dfinition de macro invalide\n\t%s\n"
					,"Invalid macro definition\n\t%s\n"),def);
			}
		}
	}
	{
		int lenrepl=0;
		if (repl != NULL){
			*repl++ = '\0';
			lenrepl = strlen(repl);
		}else{
			/* #Spcification: preprocesseur/macros

				Une macro dfinition sur la ligne de commande sans
				valeur (pas de =), prendra la valeur 1.

				Si on souhaite dfinir une macro avec la valeur vide, on
				inscrira -Dmacro= sur la ligne de commande.
			*/
			repl = "1";
		}
		preproc_putdef(buffer,repl,lenrepl,tbprm,nbprm,1);
	}
}
/*
	Saute le dfinition d'une macro #define
*/
char *token_skipmacro (char *line)
{
    int   len = strlen(line);
    outsrc_print ("%s\n",line);
    if (strncmp(line,"#define",7)==0){
		while (len > 0 && *(line+(len-1)) == '\\'){
            outsrc_print ("%s\n",line);
            filesrc_fill (line);
			len = strlen(line);
		} 
	}else if (strncmp(line,"#ifdef",6)==0){
		char *pt = line+6;
        char *finpt;
        while (isspace(*pt)) pt++;
		finpt = pt;
        while (*finpt!='\0' && !isspace(*finpt)) finpt++;
		*finpt = '\0';
		if (preproc_locate(pt) == NULL){
			/* saute jusqu'au prochain endif */
			skipif(line);
        }
		len = strlen(line);
	}	
	/* 
		Pour les autres commande du preprocesseur
		et la deniere ligne de define
		saute simplement la ligne 
	*/
	return (line+len);
}
