#include "lexc.h"

/*
	Identifie oprateur C
	Retourne nouvelle position dans buffer d'analyse
	Considre que c'est forcment un oprateur
*/

export char *token_oper (
	TOKEN *tok,
	const char *ptl)		/* Pointe sur dbut d'oprateur */
{
	char carac = *ptl ++;
	char nextcar = *ptl;
	TOK_TYPE type = TOK_BINOPER;
	int type2 = 0;
	char *text = tok->text;
	text[0] = carac;
	text[1] = '\0';
	text[2] = '\0';
	text[3] = '\0';
	switch (carac){
	case '=':
		if (nextcar == '='){
			type2 = BINOPER_EGAL;
			text[1] = '=';
			ptl++;
		}else{
			type2 = BINOPER_AFFECT;
		}
		break;
	case '*':
		if (nextcar == '='){
			type2 = BINOPER_AFF_FOIS;
			text[1] = '=';
			ptl++;
		}else{
			type = TOK_STAR;
		}
		break;
	case '-':
		if (nextcar == '='){
			type2 = BINOPER_AFF_MOINS;
			text[1] = '=';
			ptl++;
		}else if (nextcar == '-'){
			type  = TOK_UNOPER;
			type2 = UNOPER_DECREM;
			text[1] = '-';
			ptl++;
		}else if (nextcar == '>'){
			type = TOK_PTR;
			text[1] = '>';
			ptl++;
			if (ptl[0] == '*'){
				type = TOK_PTR_MEMBER;
				text[2] = '*';
				ptl++;
			}
		}else{
			type2 = BINOPER_MOINS;
		}
		break;
	case '+':
		if (nextcar == '='){
			type2 = BINOPER_AFF_PLUS;
			text[1] = '=';
			ptl++;
		}else if (nextcar == '+'){
			type  = TOK_UNOPER;
			type2 = UNOPER_INCREM;
			text[1] = '+';
			ptl++;
		}else{
			type2 = BINOPER_PLUS;
		}
		break;
	case '/':
		if (nextcar == '='){
			type2 = BINOPER_AFF_DIVIS;
			text[1] = '=';
			ptl++;
		}else{
			type2 = BINOPER_DIVIS;
		}
		break;
	case '%':
		if (nextcar == '='){
			type2 = BINOPER_AFF_MODULO;
			text[1] = '=';
			ptl++;
		}else{
			type2 = BINOPER_MODULO;
		}
		break;
	case '<':
		if (nextcar == '='){
			type2 = BINOPER_EPETIT;
			text[1] = '=';
			ptl++;
		}else if (nextcar == '<'){
			if (ptl[1] == '='){
				type2 = BINOPER_AFF_SHIFTL;
				text[1] = '<';
				text[2] = '=';
				ptl+=2;
			}else{
				type2 = BINOPER_SHIFTL;
				text[1] = '<';
				ptl++;
			}
		}else{
			type2 = BINOPER_PETIT;
		}
		break;
	case '>':
		if (nextcar == '='){
			type2 = BINOPER_EGRAND;
			text[1] = '=';
			ptl++;
		}else if (nextcar == '>'){
			if (ptl[1] == '='){
				type2 = BINOPER_AFF_SHIFTR;
				text[1] = '>';
				text[2] = '=';
				ptl+=2;
			}else{
				type2 = BINOPER_SHIFTR;
				text[1] = '>';
				ptl++;
			}
		}else{
			type2 = BINOPER_GRAND;
		}
		break;
	case '&':
		if (nextcar == '='){
			type2 = BINOPER_AFF_BITAND;
			text[1] = '=';
			ptl++;
		}else if (nextcar == '&'){
			type2 = BINOPER_BOOLAND;
			text[1] = '&';
			ptl++;
		}else{
			type2 = BINOPER_BITAND;
		}
		break;
	case '|':
		if (nextcar == '='){
			type2 = BINOPER_AFF_BITOR;
			text[1] = '=';
			ptl++;
		}else if (nextcar == '|'){
			type2 = BINOPER_BOOLOR;
			text[1] = '|';
			ptl++;
		}else{
			type2 = BINOPER_BITOR;
		}
		break;
	case '^':
		if (nextcar == '='){
			type2 = BINOPER_AFF_BITXOR;
			text[1] = '=';
			ptl++;
		}else{
			type2 = BINOPER_BITXOR;
		}
		break;
	case '!':
		if (nextcar == '='){
			type2 = BINOPER_DIFFER;
			text[1] = '=';
			ptl++;
		}else{
			type  = TOK_UNOPER;
			type2 = UNOPER_BOOLNOT;
		}
		break;
	case '~':
		type  = TOK_UNOPER;
		type2 = UNOPER_BITNOT;
		break;
	case '.':
		if (nextcar == '.' && ptl[1] == '.'){
			type  = TOK_DOT3;
			text[1] = text[2] = '.';
			ptl+= 2;
		}else{
			type = TOK_PT;
		}
		break;
	case ':':
		if (nextcar == ':'){
			type = TOK_SCOPE;
			text[1] = ':';
			ptl++;
		}else{
			type = TOK_2PT;
		}
		break;
	case '?':
		type = TOK_BINOPER;
		type2 = BINOPER_TRIEN;
		break;
	default:
		type = TOK_OTHER;
	}
	tok->type = type;
	tok->type2.other = type2;
	return (char*)ptl;
}
	

