#include <string.h>
#include "lexc.h"

/*
	Dtermine la fin d'une string
	ptl pointe sur le premier "
	Retourne pointeur sur le " de fermeture ou '\0' si erreur lexicale
*/

export char *token_skipstring (const char *ptl)
{
	ptl++;
	while (*ptl != '\0'){
		int carac = *ptl++;
        if (carac == '\\' && (*ptl == '"' || *ptl == '\\')){
			ptl++;
		}else if (carac == '"'){
			if (*ptl != '"'){
				ptl--;
				break;
			}
			ptl++;
		}
	}
	return (char*)ptl;
}	
/*
	extrait une chaine de caractre (guillemet double) d'une chaine
	Retourne pointeur aprs le " ou pointe  la fin de la chaine
	Retourne un pointeur sur n'importe quoi si lenmax est excd
*/
export char *token_copystring (
	char *text,		/* destination */
	char *ptl,		/* chaine a lire */
	int   lenmax)	/* longuer maximum */
{
	char *endptl = token_skipstring(ptl);
	int   lenptl = (int)(endptl-ptl)+1;
	if (lenptl > lenmax){
		lexcerr_bprintf ("Constante caractre trop longue\n"
			,"Character constant too long\n");
		lenptl = lenmax;
	}
	memmove (text,ptl,lenptl);
	text[lenptl] = '\0';
	if (*endptl == '\0'){
		lexcerr_bprintf ("Chaine de caractres non termine\n"
			,"Unterminated character string\n");
	}else{
		endptl++;
	}
	return (endptl);
}
/*
	Saute dfinition d'un caractre entre guillemet simple
	ptl pointe sur le premier '
	Retourne pointeur sur le ' de fermeture ou '\0' si erreur lexicale
*/
export char *token_skipquote (const char *ptl)
{
	ptl++;
	while (*ptl != '\0' && *ptl != '\''){
		int carac = *ptl++;
		if (carac == '\\' && (*ptl == '\'' || *ptl == '\\')){
			ptl++;
		}
	}
	return (char*)ptl;
}
/*
	extrait un caractre (guillemet simple) d'une chaine
	Retourne pointeur aprs le ' ou pointe  la fin de la chaine
	Retourne un pointeur sur n'importe quoi si lenmax est excd
*/
export char *token_copyquote (
	char *text,		/* destination */
	char *ptl,		/* chaine  lire */
	int lenmax)		/* longueur maximum admissible */
{
	char *endptl = token_skipquote(ptl);
	int   lenptl = (int)(endptl-ptl)+1;
	if (lenptl >=lenmax){
		lexcerr_bprintf ("Constante caractre trop longue\n"
			,"Character constant too long\n");
		lenptl = lenmax-1;
	}
	memmove (text,ptl,lenptl);
	text[lenptl] = '\0';
	if (*endptl == '\0'){
		lexcerr_bprintf ("Chaine de caractres non termine\n"
			,"Unterminated character string\n");
	}else{
		endptl++;
	}
	return endptl;
}

