#include <stdio.h>
#include <string.h>
#include <etc.h>
#include "clsinfo.h"
/*
	Affiche rcursivement l'arbre de drivation.
*/
PRIVATE int CLSFORM::printr (
	const char *base,
	FILE *fout,
	int indent,
	bool sgml)	// Formatte en sgml avec des <itemize>
{
	int nxtindent = indent + 4;
	bool one = false;
	int nbder = ders.getnb();
	for (int i=0; i<nbder; i++){
		CLS_DERIVE *ptder = ders.getitem(i);
		if (strcmp(ptder->base->nom,base)==0){
			if (sgml && !one) fprintf (fout,"%*s<itemize>\n",indent,"");
			one = true;
			CLS_INFO *info = ptder->info;
			if (sgml){
				fprintf (fout,"%*s<item>%s %s",indent,"",info->nom,ptder->opt);
			}else{
				fprintf (fout,"%*s%s %s",indent,"",info->nom,ptder->opt);
			}
			info->nbprint++;
			if (info->nbbase > 1){
				fprintf (fout," %d/%d",info->nbprint,info->nbbase);
			}
			fprintf (fout,"\n");
			if (info->nbprint == 1){
				printr (info->nom,fout,nxtindent,sgml);
			}
		}
	}
	if (sgml && one) fprintf (fout,"%*s</itemize>\n",indent,"");
	return 0;
}

static int cmp (const ARRAY_OBJ *p1, const ARRAY_OBJ *p2)
{
	CLS_DERIVE *d1 = (CLS_DERIVE *)p1;
	CLS_DERIVE *d2 = (CLS_DERIVE *)p2;
	return strcmp(d1->info->nom,d2->info->nom);
}

/*
	Affiche les classes sous forme d'arbre.
	Les classes de base apparaissent  gauche.
*/
PUBLIC int CLSFORM::print (FILE *fout, bool sgml)
{
	int nbinfo = infos.getnb();
	for (int i=0; i<nbinfo; i++){
		infos.getitem(i)->nbprint = 0;
	}
	ders.sort (cmp);
	printr("-",fout,0,sgml);
	return 0;
}

