#include <stdio.h>
#include <basio.h>
#include <etc.h>
#include <tool.h>
#include "permut.h"
#include "pagin.h"

unsigned int _stklen=20000;


static void usage()
{
	fprintf (stderr,"nacom [-s] fichier_source ...\n");
}


PUBLIC void COM_INDEX::dump (PAGIN *pout)
{
	for (int i=0; i<nbcom; i++){
		COM_SPC *spc = &tbcom[i];
		char filespec[200];
		char spec[200];
		nacom_format (spc,filespec,spec);
		if (i > 0) printf ("\n");
		printf ("%s\n%s\n",filespec,spec);
		printf ("\n");
		nacom_print (spc,pout,2);
	}
}

static void nacom_process(
	PAGIN &pout,
	char *argv[],
	int argc,
	const char *path,
	int recur)
{
	COM_INDEX comi;
	if (comi.ok()){
		if (comi.scanargv(argc,argv,path,recur) != -1){
			comi.sort();
			comi.dump(&pout);
		}
	}
}

int main (int argc, char *_argv[])
{
	int ret = -1;
	char *argv[400];
	ARGP argp[26];
	argc = anlparm_indir (argc,_argv,argv,400,argp,"s");
	if (argc < 2){
		usage();
	}else{
		int recur = argp['s'-'a'].ptr != NULL;
		PAGIN pout;
		if (pout.openerr (NULL,1,4,60,58)!=-1){
			nacom_process (pout,argv+1,argc-1,".",recur);
			pout.close ();
		}
	}
	return ret;
}


