#include <stdio.h>
#include <string.h>
#include <tool.h>
#include <misc.h>
#include <etc.h>
#include "pagin.h"
#include "permut.h"

/*
	Localise une spcification qui correspond  une cl
	Retourne -1 si trouve pas ou le prochain numro  passer  cette
	fonction pour la recherche suivante.
*/
PUBLIC int COM_INDEX::locate (
	int pos,			/* Position de depart de la recherche dans comi */ 
	const char *ident,	/* Type de spcification */
	char *tbcle[],		/* Liste de mot cle */
	int nbcle,
	COM_SPC **ptspc)		/* Contiendra la spcification trouve */
{
	int ret = -1;
	int i;
	COM_SPC *spc = tbcom + pos;
	char *lastcle = tbcle[nbcle-1];
	int subspec = 0;
	int reste = 0;
	if (strcmp(lastcle,"...")==0){
		reste = 1;
		nbcle--;
	}else if (strcmp(lastcle,"*")==0){
		subspec = 1;
		nbcle--;
	}
	for (i=pos; i<nbcom; i++,spc++){
		if (str_icmpfranc(ident,spc->ident)==0){
			/* #Spcification: nadoc / slection des spcifications
				Normalement, seuls les commentaires qui correspondent
				exactement  la commande #spec: seront imprims.

				Il y a deux exceptions. Si la dernire cl de la commande
				#spec: est un '*', alors tous les commentaires dont
				le dbut de la cl correspond seront affichs.

				Si la dernire cl de la commande est '...', Tous
				les commentaires dont le dbut correspond et qui n'ont
				pas t affichs le seront.
			*/
			int j;
			for (j=0; j<nbcle; j++){
				if (str_icmpfranc(tbcle[j],spc->tbcle[j])!=0){
					break;
				}
			}
			if (j==nbcle){
				/* Il y a un match partiel ou complet */
				if (subspec
					|| spc->nbcle == nbcle
					|| (reste && spc->usage == 0)){
					*ptspc = spc;
					ret = i+1;
					break;
				}
			}
		}
	}
	return ret;
}

/*
	Balaye une srie de source et extrait les commentaires spcifications.
*/
PUBLIC int COM_INDEX::scanargv (
	int argc,
	char *argv[],
	const char *path,
	int recur)		// Descend dans les sous-rpertoires
{
	int i;
	int ret = 0;
	for (i=0; i<argc; i++){
		char *fname = argv[i];
		char tmp[MAXSIZ_PATH];
		path_make (path,fname,tmp);
		if (file_iswild(tmp)){
			char *tb[400];
			int nb = vdir_getlistp(tmp,tb,400);
			int j;
			for (j=0; j<nb; j++){
				if (scansrc (tb[j])==-1) ret = -1;
			}
			tbstr_free (tb,nb);
		}else{
			if (scansrc (tmp)==-1) ret = -1;
		}
	}
	if (recur){
		char *tb[400];
		int nb = vdir_getlistd (path,WILD_ALLFILE,tb,NB_ELM(tb));
		for (i=0; i<nb; i++){
			fprintf (stderr,"Scan :%s:\n",tb[i]);
			ret |= scanargv (argc,argv,tb[i],recur);
		}
		tbstr_free (tb,nb);
	}
	return ret;
}

/*
	Affiche tous les commentaires spcifications qui n'ont pas t utiliss.
	Retourne le nombre de commentaires affichs.
	Si pout == NULL, ne fait que compter.
*/
PUBLIC int COM_INDEX::chknotusedp (
	PAGIN_V *pout,		// Document a gnrer ou NULL pour seulement
						// vrifier s'il y en a
	PAGIN_V *pmat)		// Table des matieres
{
	int ret = 0;
	COM_SPC *spc = tbcom;
	for (int i=0; i<nbcom; i++,spc++){
		if (spc->usage == 0){
			ret++;
			char filespec[MAXSIZ_PATH];
			char buf[300];
			nacom_format (spc,filespec,buf);
			if (pout != NULL){
				pout->format_spec (filespec,buf);
				nacom_print (spc,pout,1);
			}
			if (pmat != NULL){
				pmat->format_spec (filespec,buf);
			}
		}
	}
	return ret;
}

/*
	Affiche tous les commentaires spcifications qui n'ont pas t utiliss.
	Retourne le nombre de commentaires affichs.
*/
PUBLIC int COM_INDEX::chknotused (FILE *fout)
{
	int ret;
	PAGIN pout;
	pout.openfile (fout,4,60,58);
	pout.set_format (0);
	ret = chknotusedp (NULL,&pout);
	pout.close ();
	return ret;
}

