#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <misc.h>
#include "projet.h"
#include "projetx.m"

/*
	Change de rpertoire en prservant le rpertoire courant.
	Retourne -1 si erreur.
	Gnre un message d'erreur.
*/
int path_pushdir (
	const USERINFO *user,
	const char *path,
	SAVEPATH *save)
{
	int ret = path_pushdir (path,save);
	if (ret == -1){
		xconf_error (MSG_U(E_NODIR
			,"Ne peut accder au rpertoire\n%s")
			,path);
		user->logerr ("Ne peut selectionner le repertoire %s\n",path);
	}
	static char is_init = 0;
	static char do_trace = 0;
	if (!is_init){
		do_trace = getenv("PUSHDIR")!=NULL;
		is_init = 1;
	}
	if (do_trace){
		printf ("PUSHDIR :%s: %d\n",path,ret);
	}
	return ret;
}

/*
	Effectue un touch sur un fichier.
	Retourne -1 si erreur.
	Gnre un message d'erreur.
*/
int file_touch (
	const USERINFO *user,
	const char *fname,
	int newp)
{
	int ret = file_touch (fname,newp);
	if (ret == -1){
		xconf_error (MSG_U(E_NOTOUCH
			,"Ne peut raliser 'touch' sur le fichier\n"
			 "%s\n(%d=%s)")
			,fname,errno,strerror(errno));
		user->logerr ("Ne peut faire touch sur le fichier %s\n",fname);
	}
	return ret;
}

