#ifndef PRJLIST_H
#define PRJLIST_H

struct PRJ_INFO{
	char *nom;		// Nom du projet
	char atr;		// Code visuel qui apparaitra  sa gauche
					// dans la liste de slection, gnralement ' '
};

class USERINFO;

class PRJLISTE {
public:
	// Collecte tous les projets slectionnable.
	// Retourne le nombre de projet plac dans tbprj[].
	virtual int getlist(USERINFO *user, PRJ_INFO tbprj[],int maxtb)=0;
	// Excute l'action
	virtual int exec(USERINFO *user, int opr,
		const char *tbprj[], int nbprj)=0;
	// Obtient la table des messages pour appliquer les boutons.
	virtual const char**getbutton()=0;
	/*~PROTOBEG~ PRJLISTE */
public:
	virtual void setupdia (DIALOG&);
	virtual ~PRJLISTE (void);
	/*~PROTOEND~ PRJLISTE */
};

/*
	Manipule la liste des projets que l'usager peut accaparer.
*/
class PRJLISTE_GET: public PRJLISTE{
	/*~PROTOBEG~ PRJLISTE_GET */
public:
	int exec (USERINFO *user,
		 int ,
		 const char *tbprj[],
		 int nbprj);
	const char **getbutton (void);
	int getlist (USERINFO *user,
		 PRJ_INFO tbiprj[],
		 int maxtb);
protected:
	int subuser (USERINFO *user,
		 char *tbprj[],
		 int nbprj);
public:
	/*~PROTOEND~ PRJLISTE_GET */
};
/*
	Manipule la liste des projets que l'usager peut accaparer.
	Prsente tous les projets, mme ceux qui ne font pas partie
	de la rvision.
*/
class PRJLISTE_GETALL: public PRJLISTE_GET{
	/*~PROTOBEG~ PRJLISTE_GETALL */
public:
	int getlist (USERINFO *user,
		 PRJ_INFO tbiprj[],
		 int maxtb);
	/*~PROTOEND~ PRJLISTE_GETALL */
};

// Livraison de projet dans l'environnement usager
class PRJLISTE_LIVRE: public PRJLISTE{
public:
	SSTRING newversion;
	SSTRING comment;
	/*~PROTOBEG~ PRJLISTE_LIVRE */
public:
	int exec (USERINFO *user,
		 int opr,
		 const char *tbprj[],
		 int nbprj);
	const char **getbutton (void);
	int getlist (USERINFO *user,
		 PRJ_INFO tbiprj[],
		 int maxtb);
	void setupdia (DIALOG&dia);
	/*~PROTOEND~ PRJLISTE_LIVRE */
};

// Extraction de version intgre vers l'environnement de recompilation.
class PRJLISTE_BUILD: public PRJLISTE{
	/*~PROTOBEG~ PRJLISTE_BUILD */
public:
	int exec (USERINFO *user,
		 int opr,
		 const char *tbprj[],
		 int nbprj);
	const char **getbutton (void);
	int getlist (USERINFO *user,
		 PRJ_INFO tbiprj[],
		 int maxtb);
	/*~PROTOEND~ PRJLISTE_BUILD */
};
// Extraction de version intgre vers l'environnement de recompilation.
// Uniquement les projets qui ne font pas partie de la rvision cible.
class PRJLISTE_BUILDALL: public PRJLISTE_BUILD{
	/*~PROTOBEG~ PRJLISTE_BUILDALL */
public:
	int getlist (USERINFO *user,
		 PRJ_INFO tbiprj[],
		 int maxtb);
	/*~PROTOEND~ PRJLISTE_BUILDALL */
};

// Livraison de version intgre	
class PRJLISTE_LIVREB: public PRJLISTE_LIVRE{
	/*~PROTOBEG~ PRJLISTE_LIVREB */
public:
	int getlist (USERINFO *user,
		 PRJ_INFO tbiprj[],
		 int maxtb);
	/*~PROTOEND~ PRJLISTE_LIVREB */
};


#endif
