#include <string.h>
#include <tool.h>
#include "proto.h"
#include "proto.m"

static int alt_nb;
static char *alt_cls[50];
static char *alt_fname[50];

/*
	Enregistre un nom de fichier  gnrer plutot que le nom de la classe.
	Normalement on peut produire un fichier .pp par classe. Chaque fichier
	porte le nom de la classe. Pour MSDOS ce n'est pas appropri  cause
	de la limitation des noms de fichier.
*/
void cplus_setalt (const char *spec)
{
	char buf[300];
	char *pt;
	strcpy (buf,spec);
	pt = strchr(buf,'=');
	if (pt == NULL || strlen(pt+1) == 0 || pt - buf == 0){
		fprintf (stderr,MSG_B(E_IVLDSPEC
			,"Spcification invalide (-lclasse=fichier)\n-l%s\n"
			,"Invalid spcification (-lclass=fname)\n-l%s\n")
			,spec);
	}else{
		*pt++ = '\0';
		alt_cls[alt_nb] = strdup(buf);
		alt_fname[alt_nb] = strdup(pt);
		alt_nb++;
	}
}



/*
	Etablit le nom d'un header C++  partir de la classe ou d'un nom
	choisit par l'usager
*/
void cplus_setname (
	CPLUS *cp,
	const char *nomcls,
	const char *ext,
	char *buf)
{
	int i;
	for (i=0; i<alt_nb; i++){
		if (strcmp(alt_cls[i],nomcls)==0){
			strcpy (buf,alt_fname[i]);
			break;
		}
	}
	if (i==alt_nb){
		strcpy (buf,nomcls);
		buf[MAXSIZ_BASENAME] = '\0';
		if (*ext != '.') strcat (buf,".");
		strcat (buf,ext);
	}
	{
		CPLUS_CLS *cls = cp->cls;
		for (i=0; i<cp->nbcls; i++,cls++){
			if (strcmp(buf,cls->nomf)==0){
				fprintf (stderr,MSG_B(E_CLSCONFLICT
					,"Conflit entre classes %s et %s\n%s == %s\n"
					,"Conflicting class %s and %s\n%s == %s\n")
					,cls->nom,nomcls,buf,buf);
				break;
			}
		}
	}
}

