/*
	Imprime message d'erreur dans stderr 
*/
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "assert.h"
#include "proto.h"
#include "proto.m"

static char errstr[150];
static int nberr=0;

/*
    set preambule a placer au debut de chaque message d'erreur
*/
void erreur_setpre (char *txt)
{
	assert (strlen(txt)<sizeof(errstr)-1);
	strcpy (errstr,txt);
}
/*
	Affiche un erreur  l'cran
*/
void erreur (const char *ctl,...)
{
	va_list list;
	if (errstr[0] != '\0') fprintf (stderr,"[%s] ",errstr);
	fprintf (stderr,MSG_B(E_ERROR,"Erreur ","Error "));
	va_start (list,ctl);
	vfprintf (stderr,ctl,list);
	va_end   (list);
	nberr++;
}

/*
	Affiche un avertissement  l'cran
*/
void erreur_signal (const char *ctl, ...)
{
	va_list list;
	if (errstr[0] != '\0') fprintf (stderr,"[%s] ",errstr);
	fprintf (stderr,MSG_B(E_WARNING,"Attention ","Warning "));
	va_start (list,ctl);
	vfprintf (stderr,ctl,list);
	va_end   (list);
}

void erreur_assert (char *condit, char *file, int line)
{
	erreur (MSG_B(E_INTERNAL
		,"interne (assert) ligne %d\n"
		,"Internal (assert) line %d\n"),token_getnoline());
	fprintf (stderr,MSG_B(E_FILELINE
		,"%s : fichier %s ligne %d\n"
		,"%s : file %s line %d\n")
		,condit,file,line);
	exit (-1);
}

/*
	Retourne le nombre d'erreur durant la session d'excution
*/
int erreur_getnb(void)
{
	return nberr;
}

