#ifndef PROTO_H
#define PROTO_H

#ifndef LEXC_H
#include <lexc.h>
#endif

#include <stdio.h>

typedef struct _token_item{
	TOKEN tok;
	struct _token_item *next;
	struct _token_item *sous;
} TOKEN_ITEM;

#define MAX_TOKLEVEL	20 
typedef struct {
	TOKEN_ITEM *first;
	TOKEN_ITEM *current[MAX_TOKLEVEL];
	int curlevel;
	TOKEN_ITEM *curlec[MAX_TOKLEVEL];
	int poslec;
} TOKEN_LIST;

/*
	table pour lecture des fichier *.p *.nap *.nar (incremental)
*/
typedef struct {
	char nomf[20];		/* nom du fichier */
	unsigned long date;
	char *txt;			/* texte a generer */
} TXTPTR;
typedef struct {
	int nbsrc;
	char *buf;			/* buffer de lecture du fichier complet */
	TXTPTR *tb;
} TXTTB;

typedef struct{			/* Controle les fichier de sortie */
	FILE *fout;
	int   modeout;
	char condflg;
	TXTTB txttb;
	char *fname;
} PROTOF_INFO;

/*
	proto.exe
*/
#define MODE_ORDIN      1
#define MODE_STATIC     2
#define MODE_EXPORT     4
#define MODE_COMMENT    8
#define MODE_INDEX		16
#define MODE_PRIVATE	32
#define MODE_PROTECTED	64
#define MODE_PUBLIC		128
#define MODE_CPLUS		(MODE_PRIVATE|MODE_PROTECTED|MODE_PUBLIC)


typedef struct {
	char *nom;		/* Nom de la classe */
	char *nomf;		/* Nom du fichier associ */
} CPLUS_CLS;

typedef struct {
	CPLUS_CLS *cls;	/* Indique  quel fichier ce prototype */
					/* appartient */
	char virtuel;	/* fonction virtual ou pas */
	char scope;		/* 0: private, 1: protected, 2: public */
	char static_d;	/* fonction static ou pas */
	char *text;
	char *nomfct;	/* position du nom de la fonction dans le texte */
					/* du prototype */
} CPLUS_DECL;

typedef struct {
	CPLUS_DECL *cur;
	CPLUS_CLS  *cls;		/* Liste des classes */
	int nbcls;
	CPLUS_DECL *decl;		/* Liste des dclarations */
	int nbdecl;
	char *alloc;			/* Dbut du tampon d'allocation */
	char *ptalloc;			/* Position d'allocation */
} CPLUS;


extern char proto_formatdos;	/* Ecriture en format DOS ? */
								/* Option valide uniquement pour UNIX */
								/* en ce moment */

#include <stdarg.h>

#include "proto.p"

#endif


