/*
	Lecture de token lexicaux avec filtrage syntaxique
*/
#include <stdio.h>
#include <stdlib.h>
#include "proto.h"


/*
	Lit des token jusqu'a rencontree un terminateur de 'tb'. Si
	un demarreur est rencontree, la routine est appele recursivement.

	Retourne le numero du terminateur (0,nbtok-1) ou -1 si fin de fichier
	last contient le terminateur non accumule dans toklist
*/
int tokrec_recskipl (
	TOKEN_LIST *toklist,
	TOK_TYPE tb[][2],
	int      nbtok,
	TOKEN   *last)
{
	while (token_get(last)!=-1){
		int i;
		for (i=0; i<nbtok; i++){
			if (tb[i][0] == last->type){
				tokrec_add (toklist,last);
				tokrec_newsub (toklist);
				tokrec_recskip (toklist,tb,nbtok);
				tokrec_endsub (toklist);
				break;
			}else if(tb[i][1] == last->type){
				return (i);
			}
		}
		if (i == nbtok) tokrec_add (toklist,last);
	}
	return (-1);
} 

int tokrec_recskip (
	TOKEN_LIST *toklist,
	TOK_TYPE   tb[][2],
	int        nbtok)
{
	TOKEN token;
	int   ret = tokrec_recskipl (toklist,tb,nbtok,&token);
	if (ret != -1) tokrec_add (toklist,&token);
	return (ret);
}
/*
	Copie une sequence dans une nouvelle
*/
static void addseq (
	TOKEN_LIST *dest,
	TOKEN_ITEM *first)
{
	while (first != NULL){
		tokrec_add (dest,&first->tok);
		if (first->sous){
			tokrec_newsub (dest);
			addseq (dest,first->sous);
			tokrec_endsub (dest);
		}
		first = first->next;
	}
}
void tokrec_copy (TOKEN_LIST *newl, TOKEN_LIST *old)
{
	tokrec_init (newl);
	addseq (newl,old->first);
}

/*
	Ajoute une sequence dans une sequence deja existante
*/

void tokrec_addseq (TOKEN_LIST *dest, TOKEN_LIST *seq)
{
	addseq (dest,seq->first);
}

/*
	Ajoute le reste d'une sequence dans une sequence deja existante
*/

void tokrec_addend (
	TOKEN_LIST *dest,
	TOKEN_LIST *seq)
{
	addseq (dest,seq->curlec[seq->poslec]);
}

