#include <stdlib.h>
#include <assert.h>
#include <misc.h>
#include "ostool.h"
#include "commun.h"

/*
	Copie une srie de rpertoire dans un autre
	Retourne nombre de fichier copi ou -1 si erreur
*/

export int file_copytree (
	const char *dirsrc,
	const char *dirdst,
	const char *wild)
{
	int nb = -1;
	if (file_mkdiranc (dirdst)!=-1){
		nb = file_copy (dirsrc,dirdst,wild,NULL);
		if (nb >= 0){
			char **tbdir = (char**)malloc_err (400*sizeof(char*));
			if (tbdir == NULL){
				nb = -1;
			}else{
				int nbd = dir_getlistd (dirsrc,WILD_ALLFILE,0,tbdir,400);
				int i;
				tbdir = (char**)realloc (tbdir,(nbd+1)*sizeof(char*));
				assert (tbdir!=NULL);
				for (i=0; i<nbd; i++){
					int ok;
					char sub[20];
					char newdst[MAXSIZ_PATH];
					path_splitlex (tbdir[i],NULL,sub);
					path_make (dirdst,sub,newdst);
					ok = file_copytree (tbdir[i],newdst,wild);
					if (ok == -1){
						nb = -1;
						break;
					}else{
						nb += ok;
					}
				}
				tbstr_free (tbdir,nbd);
				free (tbdir);
			}
		}
	}
	return nb;
}

#ifdef TEST

void main (void)
{
	printf ("File_copytree \\prj\\*.c f:\\prj -> %d\n"
		,file_copytree("\\prj","f:\\prj","*.c"));
}

#endif

