#include <string.h>
#include <misc.h>
#include "ostool.h"
#include "commun.h"

/*
	Etablie la valeur relle d'un path.

	Souvent un path est donne par l'usager et contient un lien
	symbolique. Certain autre path sont obtenue via d'autre mcanisme
	(path_getcwd() par exemple) et donnent le rpertoire rel sans
	lien symbolique. Certain programme compare le dbut de deux paths
	pour dterminer s'il sont commun. Dans ce cas, ca rate, mme si en
	fait deux path reprsente (vue de l'usager) la mme branche.

	Souvent le rpertoire HOME est en fait un path avec lien symbolique.
	Ca simplifie l'administation.

	Sauf que si on fait un getcwd() dans un sous rpertoire, on obtient
	une chaine qui ne contient pas la chaine home. C'est dplaisant.

	sympath peut tre le path d'un rpertoire ou un fichier.

	Retourne -1 si erreur.
*/
export int path_cnv2reel (const char *sympath, char *reelpath)
{
	int ret = -1;
	SAVEPATH save;
	char tmpsym[MAXSIZ_PATH];	/* remplace sympath, si c'est un fichier */
	char fname[MAXSIZ_NAME];	/* Nom du fichier ou '\0' */
	fname[0] = '\0';
	strcpy (reelpath,sympath);	/* Solidifie les clients qui vrifie pas */
								/* Les codes d'erreur */
	if (file_type(sympath)==0){
		path_splitlex (sympath,tmpsym,fname);
		sympath = tmpsym;
	}
	if (file_type(sympath)==1){
		if (path_pushdir (sympath,&save) != -1){
			ret = path_getcwd (reelpath,MAXSIZ_PATH);
			if (ret != -1 && fname[0] != '\0'){
				path_make (reelpath,fname,reelpath);
			}
			path_popdir  (&save);
		}
	}
	return ret;
}

