/*
	Programme qui mule la commande del de DOS avec rpertoire virtuel
*/
#include <assert.h>
#include <string.h>
#include <etc.h>
#include <basio.h>
#include "ostool.h"
#include "commun.h"

unsigned int _stklen = 20000;

static void near usage(void)
{
	fprintf (stderr
		,"pdel version 1.05\n"
		"pdel fichiers ...\n"
		"Efface un fichier d'un rpertoire virtuel.\n"
		);
}

static FILE *fout = NULL;		/* Ouvre le fichier makefile.del seulement */
								/* si requis */

static int near pdel_do (const char *fwild)
{
	int ret = -1;
	char *tb[400];
	int nb = vdir_getlistp (fwild,tb,400);
	
	if (nb > 0){
		int i;
		ret  = 0;
		for (i=0; i<nb && ret != -1; i++){
			char *fname = tb[i];
			/* #Spcification: pdel / fichiers spciaux
				les fichiers makefile.del et makefile.dat ne peuvent
				pas tre effacs par pdel, mme explicitement (sans
				usage de wildcards).
			*/
			if (strcmp(fname,"makefile.dat")!=0
				&& strcmp(fname,"makefile.del")!=0){
				int exist = vdir_exist(fname,NULL);
				assert (exist);
				if (exist == 1){
					/*
						le fichier est prsent localement dans le
						rpertoire.
					*/
					ret = file_unlink (fname);
				}
				if (ret != -1){
					char name[MAXSIZ_NAME];
					/* Calcul le path du fichier makefile.del */
					char pathdel[MAXSIZ_PATH];
					static char lastpath[MAXSIZ_PATH]={'\0'};
					path_splitlex (fname,pathdel,name);
					path_make     (pathdel,"makefile.del",pathdel);
					if (strcmp(pathdel,lastpath)!=0){
						if (fout != NULL) fclose (fout);
						fout = fopen_err (pathdel,"a",1);
						strcpy (lastpath,pathdel);
					}
					fprintf (fout,"%s\n",name);
				}
			}
		}
	}else if (file_iswild(fwild)){
		error_bprintf ("Aucun fichier correspondant  %s\n"
			,"No file matching %s\n",fwild);
	}else{
		error_bprintf ("Pas de fichier %s\n","No such file %s\n",fwild);
	}
	return ret;
}

int main (int argc, char *argv[])
{
	int ret = -1;
	if (argc < 2){
		usage();
	}else{
		int i;
		ret = 0;
		for (i=1; i<argc && ret != -1; i++){
			char *fname = argv[i];
			if (!file_iswild(fname) && file_type(fname) == 1){
				error_bprintf ("Efface rpertoire %s ???\n"
					,"Erase directory %s ???\n",fname);
				ret = -1;
			}else{
				ret = pdel_do (fname);
			}
		}
		if (fout != NULL) fclose (fout);
	}
	if (fout != NULL) fclose (fout);
	return ret;
}

