#include <stdio.h>
#include <stdlib.h>
#include "ostool.h"
#include "commun.h"

/*
	Obtient la liste des fichiers correspondant  fwild

	Retourne le nombre plac dans tb.
	L'appelant est responsable de libr les lments dans tb[].
*/
export int vdir_getlist(
	const char *path,
	const char *wild,
	char *tb[],
	int maxtb)
{
	FILEDIR *fdir = vdir_setup(path,0,NULL);
	return filedir_getlist (fdir,wild,tb,maxtb,path);
}
/*
	Obtient la liste des fichiers correspondant  fwild

	Retourne le nombre plac dans tb.
	L'appelant est responsable de libr les lments dans tb[].
*/
export int vdir_getlistp(const char *fwild, char *tb[], int maxtb)
{
	char addpath[MAXSIZ_PATH];
	char wild[MAXSIZ_NAME];
	path_splitlex (fwild,addpath,wild);
	return vdir_getlist (addpath,wild,tb,maxtb);
}
/*
	Obtient la liste des sous-rpertoire correspondant  fwild

	Retourne le nombre plac dans tb.
	L'appelant est responsable de libr les lments dans tb[].
*/
export int vdir_getlistd(
	const char *path,
	const char *wild,
	char *tb[],
	int maxtb)
{
	FILEDIR *fdir = vdir_setup(path,0,NULL);
	return filedir_getlistd (fdir,wild,tb,maxtb,path);
}
/*
	Obtient la liste des sous-rpertoires correspondant  fwild

	Retourne le nombre plac dans tb.
	L'appelant est responsable de libr les lments dans tb[].
*/
export int vdir_getlistdp(const char *fwild, char *tb[], int maxtb)
{
	char addpath[MAXSIZ_PATH];
	char wild[MAXSIZ_NAME];
	path_splitlex (fwild,addpath,wild);
	return vdir_getlistd (addpath,wild,tb,maxtb);
}

#ifdef TEST

#include <stdio.h>
#include <etc.h>

unsigned int _stklen=10000;

static void near tst_exist (const char *fname)
{
	char reel[MAXSIZ_PATH];
	int type;
	if (vdir_exist (fname,reel)){
		printf ("%s existe -> %s\n",fname,reel);
	}else{
		printf ("%s existe pas\n",fname);
	}
	type = vdir_ftype (fname,reel);
	if (type != -1){
		printf ("%s type %d -> %s\n",fname,type,reel);
	}else{
		printf ("%s existe pas\n",fname);
	}
}

int main (int argc, char *argv[])
{
	int i;
	char *tb[200];
	int nb = vdir_getlistp ("e:\\kit\\build\\_1_0\\adm\\projet\\*.c",tb,200);
	for (i=0; i<nb;  i++){
		printf ("%2d - %s\n",i+1,tb[i]);
	}
	nb = vdir_getlistp ("..\\commun\\*.c",tb,200);
	for (i=0; i<nb;  i++){
		printf ("%2d - %s\n",i+1,tb[i]);
	}
	tbstr_free (tb,nb);
	vdir_setrelatif ("e:\\kit\\ombre");
	for (i=0; i<2; i++){
		tst_exist("usrbrk.c");	
		tst_exist("vdir.c");
		tst_exist("rules.mak");
		tst_exist("..\\rules.mak");
	}
}

#endif

