/*
	opration spcifique sur rpertoire
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <misc.h>
#include "tool.h"
#include "../common/commun.h"
/*
	Copie la structure de sous-rpertoire d'un path dans un autre
	Retourne -1 si erreur, 0 si ok
*/

export int dir_copystruct(
	const char *refpath,	/* reference  utiliser	pour crer les dir */
	const char *wrkpath)	/* destination */
							/* si existe pas, tente de crer */
{
	int ret = 0;
	if (file_type(wrkpath)==1 || file_mkdir	(wrkpath) != -1){
		char **tb = (char**)malloc(400);
		char reftmp[MAXSIZ_PATH];
		path_addback(refpath,reftmp);
		if (tb != NULL){
			int lenref = strlen(reftmp);
			int nbdir = dir_getlistd (refpath,"*.*",100,tb,400);
			int i;
			for (i=0; i<nbdir; i++){
				char path[MAXSIZ_PATH];
				path_make (wrkpath,tb[i]+lenref,path);
				if (file_type(path)!=1){
					if (file_mkdir (path)==-1) ret = -1;
				}
				free (tb[i]);
			}
			free (tb);
		}else{
			ret = -1;
		}
	}else{
		ret = -1;
	}
	return (ret);
}

/*
	Dtruit un rpertoire et son contenu recursivement
	Retourne 0 si ok, -1 si	erreur
*/

export int dir_delete (
	const char *path,
	const char *wild)	/* Si NULL, dtruit le rpertoire aussi */
{
	int ret = -1;
	int deldir = 0;
	char **tb = (char**)malloc (400*sizeof(char**));
	if (wild == NULL){
		wild = "*";
		deldir = 1;
	}
	if (tb != NULL){
		int	nbdir =	dir_getlistd (path,"*",100,&tb[1],399)+1;
		int i;
		tb[0] = strdup (path);
		/* balaye en reculant pour dtruire les sous-rpertoires avant */
		ret = 0;
		for (i=nbdir-1; i>=0; i--){
			char path[MAXSIZ_PATH];
			path_make (tb[i],wild,path);
			ret |= file_unlink (path);
			if (deldir)	ret	|= file_rmdir(tb[i]);
			free (tb[i]);
		}
		free (tb);
	}
	return (ret);
}

#ifdef TEST

void main(void)
{
	if (file_mkdir ("/tmp/$$$")!=-1){
		system ("xcopy /usr/prj1/ /tmp/$$$");
		system ("sh");
		dir_delete ("/tmp/$$$","*.c");
		system ("sh");
		dir_delete ("/tmp/$$$",NULL);
		system ("sh");
		dir_copystruct ("/usr/prj","/tmp/prj");
		system ("sh");
		dir_delete ("/tmp/prj",NULL);
	}else{
		printf ("Ne peut pas crer de rpertoire temporaire\n");
	}
}
#endif
