#include <sys/vfs.h>
#include "tool.h"

/*
	Retourne l'espace libre dans une partition en K
	Retourne -1 si erreur.
*/
export long file_getfree (const char *path)
{
	struct statfs buf;
	long ret = statfs (path,&buf);
	if (ret != -1){
		// printf ("buf avail %ld\n",buf.f_bavail);
		// printf ("buf size %ld\n",buf.f_bsize);
		while (buf.f_bsize < 1024){
			buf.f_bsize <<=1;
			buf.f_bavail >>=1;
		}
		while (buf.f_bsize > 1024){
			buf.f_bsize >>=1;
			buf.f_bavail <<=1;
		}
		ret = buf.f_bavail;
	}
	return ret;
}

/*
	Retourne la longueur maximum permise pour un nom de fichier
	(Spcifique au type de file system).
	Retourne -1 si erreur.
*/
export int file_getname_len (const char *path)
{
	struct statfs buf;
	int ret = statfs (path,&buf);
	if (ret != -1){
		ret = buf.f_namelen;
	}
	return ret;
}

