#include <stdlib.h>
#include <string.h>
#include "tool.h"
#include <misc.h>

/*
	Traitement initial protgeant l'tat courant d'un fichier  rviser
	filebak_ok et filebak_abort seront appel aprs la rvision du fichier.
	Ce systme est compliqu parce que le traitement sur UNIX est diffrent.
	(dans UNIX on ne peut pas simplement renommer le fichier  protger et
	crer un autre  0, car les privilges seront perdus).

	Sous UNIX, on copie immdiatement le fichier dans le fichier .extbak.
	Retourne -1 si erreur, ou permission pas accorde.

	Fonction mme si le fichier fname n'existe pas.
*/
export int filebak_before (
	const char *fname,	/* Fichier qui sera rvis */
	const char *extbak,	/* extension du fichier  conserver */
	char *ftmp,			/* Fichier qui contient temporairement l'tat de fname */
	char *fwork)		/* Fichier  produire */
{
	int ret = -1;
	file_chgext (fname,ftmp,extbak);
	strcpy (fwork,fname);
	if (file_writeok(fname)
		&& (!file_exist(fname) || file_copyp (fname,ftmp) != -1)){
		ret = 0;
	}
	return ret;
}
/*
	Traitement final protgeant l'tat courant d'un fichier en rvision
	On repasse simplement les mme arguments qu' filebak_before().
*/
export int filebak_ok (
	const char *,	/* Fichier qui sera rvis */
	const char *,	/* extension du fichier  conserver */
	char *,			/* Fichier qui contient temporairement l'tat de fname */
	char *)			/* Fichier  produire */
{
	return 0;
}
/*
	Abandon du traitement de rvision d'un fichier.
	On replace le fichier dans son tat original.
*/
export int filebak_abort (
	const char *fname,	/* Fichier qui sera rvis */
	const char *,	/* extension du fichier  conserver */
	char *ftmp,			/* Fichier qui contient temporairement l'tat de fname */
	char *)		/* Fichier  produire */
{
	int ret = 0;
	if (file_exist(ftmp)){
		ret = file_copyp (ftmp,fname);
	}
	return ret;
}


