/*
	Opration sur la variable d'environnement PATH
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <misc.h>
#include "../../etc/etc.h"
#include "tool.h"


/*
	Dcompose une variable d'environnement comme PATH en une srie d'argument
	
	Le sparateur est un ';'
	Retourne le nombre d'lment plac dans tb
*/
export int path_varenvsplit (
	const char *nomvar,	/* Nom de la variable */
	char *tb[])		/* Contiendra un path absolue pour recherche exec */
					/* alloue par strdup() */
					/* utilis tbstr_free() pour librer */
{
	int nb = 0;
	char *varbuf = getenv(nomvar);
	if (varbuf != NULL){
		nb = tbstr_str2tb (varbuf,':',tb);
		tbstr_skipstrip	(tb,nb);
	}
	return (nb);
}

/*
	Vrifie si la variable PATH contient des path valides
	Retourne -1 si un des path est invalide, sinon retourne le 
	nombre de path
*/
export int path_validate (void)
{
	char *tb[50];
	int nb = path_varenvsplit("PATH",tb);
	int ret = nb;
	int i;
	for (i=0; i<nb; i++){
		char buf[100];
		path_setabs (tb[i],buf);
		path_stripsep (buf,buf);
		if (file_type (buf) != 1){
			ret	= -1;
			break;
		}
	}
	tbstr_free (tb,nb);
	return (ret);
}


#ifdef TEST

static void	test (const	char *str)
{
	char buf[300];
	sprintf (buf,"PATH=%s",str);
	putenv (buf);
	printf ("%-40s -> %d\n",buf,path_validate());
}

void main(void)
{
	test (getenv("PATH"));
	test ("/bin:/etc");
	test ("/bin");
	/* invalide	*/
	test ("/bin:/toto");
	test ("");
}

#endif
