#include <stdio.h>
#include <string.h>
#include "tool.h"
#include "../common/commun.h"
#include <misc.h>

/*
	Comme filebak_before, mais traitement des rpertoires virtuels
*/
export int vfilebak_before (
	const char *fname,	/* Fichier qui sera rvis */
	const char *extbak,	/* extension du fichier  conserver */
	char *ftmp,			/* Fichier qui contient temporairement l'tat de fname */
	char *fwork)		/* Fichier  produire */
{
	int ret = -1;
	if (file_exist(fname)){
		ret = filebak_before(fname,extbak,ftmp,fwork);
	}else{
		strcpy (fwork,fname);
		ret = vdir_exist(fname,ftmp) ? 0 : -1;
	}
	return ret;
}
/*
	Comme filebak_ok, mais traitement des rpertoires virtuels
*/
export int vfilebak_ok (
	const char *,	/* Fichier qui sera rvis */
	const char *,	/* extension du fichier  conserver */
	char *,			/* Fichier qui contient temporairement l'tat de fname */
	char *)			/* Fichier  produire */
{
	return 0;
}
/*
	Comme filebak_abort, mais traitement des rpertoires virtuels
*/
export int vfilebak_abort (
	const char *fname,	/* Fichier qui sera rvis */
	const char *extbak,	/* extension du fichier  conserver */
	char *ftmp,			/* Fichier qui contient temporairement l'tat de fname */
	char *fwork)		/* Fichier  produire */
{
	int ret = 0;
	char old[MAXSIZ_PATH];
	file_chgext (fname,old,extbak);
	if (strcmp(old,ftmp)==0){
		ret = filebak_abort (fname,extbak,ftmp,fwork);
	}else{
		ret = file_unlink (fwork);
	}
	return ret;
}



